<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="时间" prop="studyTime">
        <el-date-picker clearable
                        v-model="queryParams.studyTime"
                        type="date"
                        value-format="yyyy-MM-dd"
                        placeholder="请选择时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="地点" prop="studyVenue">
        <el-input v-model="queryParams.studyVenue" placeholder="请输入地点"/>
      </el-form-item>
      <el-form-item label="内容" prop="contents">
        <el-input v-model="queryParams.contents" placeholder="请输入内容"/>
      </el-form-item>
      <el-form-item label="备注" prop="remarks">
        <el-input v-model="queryParams.remarks" placeholder="请输入备注"/>
      </el-form-item>
      <el-form-item label="归属部门" prop="deptId" style="width: 268px;">
        <treeselect style="width: 200px;" v-model="queryParams.deptId" :options="deptOptions" :show-count="true"
                    placeholder="请选择归属部门"/>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['branch:study:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['branch:study:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['branch:study:remove']"
        >删除
        </el-button>
      </el-col>
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="info"-->
          <!--plain-->
          <!--icon="el-icon-upload2"-->
          <!--size="mini"-->
          <!--@click="handleImport"-->
          <!--v-hasPermi="['branch:study:edit']"-->
        <!--&gt;导入-->
        <!--</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="warning"-->
          <!--plain-->
          <!--icon="el-icon-download"-->
          <!--size="mini"-->
          <!--@click="handleExport"-->
          <!--v-hasPermi="['branch:study:export']"-->
        <!--&gt;导出-->
        <!--</el-button>-->
      <!--</el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="studyList" @selection-change="handleSelectionChange" :height="clientHeight"
              border>
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="时间" align="center" prop="studyTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.studyTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="地点" align="center" prop="studyVenue"/>
      <el-table-column label="授课人" align="center" prop="lecturerString" width="120"/>
      <el-table-column label="记录人" align="center" prop="recorderString" width="120"/>
      <el-table-column label="参加人员" align="center" prop="participantsString" width="120"/>
      <el-table-column label="缺席人员" align="center" prop="absenteesString" width="120"/>
      <el-table-column label="内容" align="left" prop="contents" width="350"/>
      <el-table-column label="附件" align="center" prop="filesId" width="100">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-folder"
            @click="openFileDialog(scope.row)"
          >查看附件
          </el-button>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks"/>
      <el-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['branch:study:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['branch:study:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改支部党课学习对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="时间" prop="studyTime">
          <el-date-picker clearable size="small" style="width: 200px"
                          v-model="form.studyTime"
                          type="date"
                          value-format="yyyy-MM-dd"
                          placeholder="选择时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="地点" prop="studyVenue">
          <el-input v-model="form.studyVenue" placeholder="请输入地点"/>
        </el-form-item>
        <el-form-item label="授课人" prop="lecturer">
          <el-select v-model="form.lecturer" multiple placeholder="请选择授课人">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="记录人" prop="recorder">
          <el-select v-model="form.recorder" multiple placeholder="请选择记录人">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="参加人员" prop="participants">
          <el-select v-model="form.participants" multiple placeholder="请选择参加人员">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="缺席人员" prop="absentees">
          <el-select v-model="form.absentees" multiple placeholder="请选择缺席人员">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="内容" prop="contents">
          <el-input v-model="form.contents" placeholder="请输入内容" type="textarea" rows="4"/>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
        <el-form-item label="归属部门" prop="deptId">
          <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport"/>
          是否更新已经存在的用户数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog title="附件详情" :visible.sync="file.open" width="60%" append-to-body>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-upload
            ref="doc"
            :headers="doc.headers"
            :action="doc.url+'?tableName=branchStudy&tableId=' + doc.tableId"
            :disabled="doc.isUploading"
            :on-progress="handleFileDocProgress"
            :on-success="handleFileDocSuccess"
            :auto-upload="true"
            :file-list="file.fileList"
          >
            <el-button type="primary"><i class="el-icon-upload"></i> 点击上传</el-button>
          </el-upload>
        </el-col>
      </el-row>
      <el-table :data="file.dataList">
        <el-table-column label="附件名称" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-document"
              @click="handleSee(scope.row.url)">
              {{ scope.row.name }}
            </el-button>
          </template>
        </el-table-column>
        <el-table-column label="上传人" align="center" prop="creater"/>
        <el-table-column label="上传时间" align="center" prop="createdate">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.createdate, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteFile(scope.row.id)"
            >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>
  </div>
</template>

<script>
import {listStudy, getStudy, delStudy, addStudy, updateStudy, exportStudy, importTemplate} from "@/api/branch/study";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {listUserNoPage} from "@/api/system/user";
import {delFile, listFile} from "../../../../api/branch/file";

export default {
  name: "Study",
  components: {Treeselect},
  data() {
    return {
      file: {
        id: null,
        open: false,
        fileList: [],
        dataList: [],
      },
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        tableId: 0,
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/branch/file/uploadFile",
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 支部党课学习表格数据
      studyList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: [],
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/branch/study/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        studyId: null,
        studyTime: null,
        studyVenue: null,
        lecturer: null,
        recorder: null,
        participants: null,
        absentees: null,
        contents: null,
        remarks: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        studyTime: [
          {required: true, message: "时间不能为空", trigger: "blur"}
        ],
        studyVenue: [
          {required: true, message: "地点不能为空", trigger: "blur"}
        ],
        deptId: [
          {required: true, message: "归属部门不能为空", trigger: "blur"}
        ],
      },
      // 用户列表
      userList: [],
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 250
    })
    this.getList();
    this.getTreeselect();
  },
  methods: {
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      console.log(response.data, '-----', this.file.id);
      this.$modal.msgSuccess("上传成功");
      this.getFileList();
    },
    /** 查询用户列表 */
    getUserList() {
      listUserNoPage().then(response => {
        let rows = response.data;
        let userList = [];
        for (let i = 0; i < rows.length; i++) {
          if (rows[i].userName != "admin") {
            let user = {"dictValue": rows[i].userId, "dictLabel": rows[i].nickName};
            userList.push(user);
          }
        }
        this.userList = userList;
      });
    },
    handleSee(url) {
      window.open(process.env.VUE_APP_BASE_API + url);
    },
    openFileDialog(row) {
      console.log(row)
      this.file.open = true;
      this.doc.tableId = row.studyId;
      this.getFileList();
    },
    getFileList() {
      listFile({tableId: this.doc.tableId, tableName: 'branchStudy'}).then(res => {
        this.file.dataList = res.data
      })
    },
    handleDeleteFile(id) {
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delFile(id);
      }).then(() => {
        this.getFileList();
        this.msgSuccess("删除成功");
      })
    },
    /** 查询支部党课学习列表 */
    getList() {
      this.loading = true;
      listUserNoPage().then(response => {
        let rows = response.data;
        let userList = [];
        for (let i = 0; i < rows.length; i++) {
          if (rows[i].userName != "admin") {
            let user = {"dictValue": rows[i].userId, "dictLabel": rows[i].nickName};
            userList.push(user);
          }
        }
        this.userList = userList;
        listStudy(this.queryParams).then(response => {
          this.studyList = response.rows;
          for (let i = 0; i < this.studyList.length; i++) {
            if (this.studyList[i].lecturer != null) {
              let lecturer = this.studyList[i].lecturer.split(",");
              let lecturerString = "";
              for (let j = 0; j < lecturer.length; j++) {
                if (j > 0) {
                  lecturerString += "、" + this.selectDictLabel(this.userList, lecturer[j]);
                } else {
                  lecturerString += this.selectDictLabel(this.userList, lecturer[j]);
                }
              }
              this.studyList[i].lecturerString = lecturerString;
            }
            if (this.studyList[i].recorder != null) {
              let recorder = this.studyList[i].recorder.split(",");
              let recorderString = "";
              for (let j = 0; j < recorder.length; j++) {
                if (j > 0) {
                  recorderString += "、" + this.selectDictLabel(this.userList, recorder[j]);
                } else {
                  recorderString += this.selectDictLabel(this.userList, recorder[i]);
                }
              }
              this.studyList[i].recorderString = recorderString;
            }
            if (this.studyList[i].participants != null) {
              let participants = this.studyList[i].participants.split(",");
              let participantsString = "";
              for (let j = 0; j < participants.length; j++) {
                if (j > 0) {
                  participantsString += "、" + this.selectDictLabel(this.userList, participants[j]);
                } else {
                  participantsString += this.selectDictLabel(this.userList, participants[j]);
                }
              }
              this.studyList[i].participantsString = participantsString;
            }
            if (this.studyList[i].absentees != null) {
              let absentees = this.studyList[i].absentees.split(",");
              let absenteesString = "";
              for (let j = 0; j < absentees.length; j++) {
                if (j > 0) {
                  absenteesString += "、" + this.selectDictLabel(this.userList, absentees[j]);
                } else {
                  absenteesString += this.selectDictLabel(this.userList, absentees[j]);
                }
              }
              this.studyList[i].absenteesString = absenteesString;
            }
          }
          this.total = response.total;
          this.loading = false;
        });
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        studyId: null,
        studyTime: null,
        studyVenue: null,
        lecturer: null,
        recorder: null,
        participants: null,
        absentees: null,
        contents: null,
        remarks: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.studyId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加支部党课学习";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const studyId = row.studyId || this.ids
      getStudy(studyId).then(response => {
        this.form = response.data;
        if (this.form.lecturer != null) {
          this.form.lecturer = this.form.lecturer.split(",").map(Number);
        }
        if (this.form.recorder != null) {
          this.form.recorder = this.form.recorder.split(",").map(Number);
        }
        if (this.form.participants != null) {
          this.form.participants = this.form.participants.split(",").map(Number);
        }
        if (this.form.absentees != null) {
          this.form.absentees = this.form.absentees.split(",").map(Number);
        }
        this.open = true;
        this.title = "修改支部党课学习";
      });
    },
    /** 提交按钮 */
    submitForm() {
      if (this.form.lecturer != null) {
        this.form.lecturer = this.form.lecturer.join();
      }
      if (this.form.recorder != null) {
        this.form.recorder = this.form.recorder.join();
      }
      if (this.form.participants != null) {
        this.form.participants = this.form.participants.join();
      }
      if (this.form.absentees != null) {
        this.form.absentees = this.form.absentees.join();
      }
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.studyId != null) {
            updateStudy(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addStudy(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const studyIds = row.studyId || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delStudy(studyIds);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有支部党课学习数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportStudy(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    }
  }
};
</script>
<style>
/** 文本换行符处理 */
.el-table .cell {
  white-space: pre-wrap;
}

/** textarea字体 */
textarea {
  font-family: "Helvetica Neue", Helvetica, "PingFang SC", "Hiragino Sans GB", "Microsoft YaHei", "微软雅黑", Arial, sans-serif;
}
</style>
